/* ***************
// Desc: JS File for QuickNote, this is where all the loading and saving of the file is.
// 
// Author: Jed Brown (jedbro@gmx.net)
// Additional code taken from Cdn's Chrome Edit extension.
// Contributor: Ponomarev Nickolay (gen57@bk.ru)
//   TODO: suggesting rewrite of save/load functions -- use indexes instead of IDs as parameters.
// Version: 0.4.5
// Last modified: January 28th, 2004
****************** */
try {
	// These will not be set on first QN load so it will except here.
	const pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var tabtosendto = pref.getIntPref('quicknote.totabint',null);
	var qnlangPref = pref.getBoolPref('quicknote.langsupport');
	var userdefinedtab1file = nsPreferences.getLocalizedUnicharPref('quicknote.tab1path');
	var userdefinedtab2file = nsPreferences.getLocalizedUnicharPref('quicknote.tab2path');
	var userdefinedtab3file = nsPreferences.getLocalizedUnicharPref('quicknote.tab3path');
	var userdefinedtab4file = nsPreferences.getLocalizedUnicharPref('quicknote.tab4path');
	var qnfirststart = pref.getBoolPref('quicknote.firststart');
	var qnshowurl = pref.getBoolPref('quicknote.showUrl');
	var numberoftabs = pref.getIntPref('quicknote.numtabs',null);
	var howtopenQN = pref.getIntPref('quicknote.openqn',null);
	
	var onePadfontSizetab = pref.getIntPref("quicknote.fontsize1");
	var onePadfontNametab = pref.getCharPref("quicknote.fontname1");
	var onePadfontColortab = pref.getCharPref("quicknote.fontcolor1");
	var onePadUserStyletab = pref.getCharPref("quicknote.userstyle1");
	var oneTabBGColor = pref.getCharPref("quicknote.bgcolortab1");
	
	var twoPadfontSizetab = pref.getIntPref("quicknote.fontsize2");
	var twoPadfontNametab = pref.getCharPref("quicknote.fontname2");
	var twoPadfontColortab = pref.getCharPref("quicknote.fontcolor2");
	var twoPadUserStyletab = pref.getCharPref("quicknote.userstyle2");
	var twoTabBGColor = pref.getCharPref("quicknote.bgcolortab2");
	
	var threePadfontSizetab = pref.getIntPref("quicknote.fontsize3");
	var threePadfontNametab = pref.getCharPref("quicknote.fontname3");
	var threePadfontColortab = pref.getCharPref("quicknote.fontcolor3");
	var threePadUserStyletab = pref.getCharPref("quicknote.userstyle3");
	var threeTabBGColor = pref.getCharPref("quicknote.bgcolortab3");
	
	var fourPadfontSizetab = pref.getIntPref("quicknote.fontsize4");
	var fourPadfontNametab = pref.getCharPref("quicknote.fontname4");
	var fourPadfontColortab = pref.getCharPref("quicknote.fontcolor4");
	var fourPadUserStyletab = pref.getCharPref("quicknote.userstyle4");
	var fourTabBGColor = pref.getCharPref("quicknote.bgcolortab4");
	
}catch (e) {
	// foobar! This lets us continue.
	// Now lets set the defaults
	// This will allow us to clean up the qnsettings.js file (Not done yet)
	var userdefinedtab1file = nsPreferences.setUnicharPref('quicknote.tab1path', "Blank");
	var userdefinedtab2file = nsPreferences.setUnicharPref('quicknote.tab2path', "Blank");
	var userdefinedtab3file = nsPreferences.setUnicharPref('quicknote.tab3path', "Blank");
	var userdefinedtab4file = nsPreferences.setUnicharPref('quicknote.tab4path', "Blank");
	var howtopenQN = nsPreferences.setIntPref('quicknote.openqn',"1");
	
	var onePadfontSizetab = nsPreferences.setIntPref("quicknote.fontsize1", "12");
	var onePadfontNametab = nsPreferences.setUnicharPref("quicknote.fontname1", "Verdana,sans-serif");
	var onePadfontColortab = nsPreferences.setUnicharPref("quicknote.fontcolor1", "black");
	var onePadUserStyletab = nsPreferences.setUnicharPref("quicknote.userstyle1", "");
	var oneTabBGColor = nsPreferences.setUnicharPref("quicknote.bgcolortab1", "white");
	
	var twoPadfontSizetab = nsPreferences.setIntPref("quicknote.fontsize2", "12");
	var twoPadfontNametab = nsPreferences.setUnicharPref("quicknote.fontname2", "Verdana,sans-serif");
	var twoPadfontColortab = nsPreferences.setUnicharPref("quicknote.fontcolor2", "black");
	var twoPadUserStyletab = nsPreferences.setUnicharPref("quicknote.userstyle2", "");
	var twoTabBGColor = nsPreferences.setUnicharPref("quicknote.bgcolortab2", "white");
	
	var threePadfontSizetab = nsPreferences.setIntPref("quicknote.fontsize3", "12");
	var threePadfontNametab = nsPreferences.setUnicharPref("quicknote.fontname3", "Verdana,sans-serif");
	var threePadfontColortab = nsPreferences.setUnicharPref("quicknote.fontcolor3", "black");
	var threePadUserStyletab = nsPreferences.setUnicharPref("quicknote.userstyle3", "");
	var threeTabBGColor = nsPreferences.setUnicharPref("quicknote.bgcolortab3", "white");
	
	var fourPadfontSizetab = nsPreferences.setIntPref("quicknote.fontsize4", "12");
	var fourPadfontNametab = nsPreferences.setUnicharPref("quicknote.fontname4", "Verdana,sans-serif");
	var fourPadfontColortab = nsPreferences.setUnicharPref("quicknote.fontcolor4", "black");
	var fourPadUserStyletab = nsPreferences.setUnicharPref("quicknote.userstyle4", "");
	var fourTabBGColor = nsPreferences.setUnicharPref("quicknote.bgcolortab4", "white");

}
 
function closeWindow()
{
  window.close();
}

function getTextareaText(tNodeID) {
 var tat = document.getElementById(tNodeID).value;
 if (qnlangPref){
	 return escape(tat);
 }else{
	 return tat;
 }
}

function setTextareaText(thetext,tNodeID) {
 document.getElementById(tNodeID).value= unescape(thetext);
}


////////////////////////////////////////////////////////////////////////////////
// loadtheFiles
//
// Desc: This function decides whether to load user defined files or create new quicknot1.txt, 2.. in the profile dir.
// Parameters: userTabpath: The name and path of the file to load . 
//             targetNodeID: Where it is headed to (onePad, twoPad.. etc.)
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
function loadtheFiles(userTabpath,targetNodeID) {
	if(userTabpath==null || userTabpath=='Blank' || !userTabpath ){
		if(targetNodeID == "onePad")
		{
			loadIt('quicknote1.txt',targetNodeID);
		}
		if(targetNodeID == "twoPad")
		{
			loadIt('quicknote2.txt',targetNodeID);
		}
		if(targetNodeID == "threePad")
		{
			loadIt('quicknote3.txt',targetNodeID);
		}
		if(targetNodeID == "fourPad")
		{
			loadIt('quicknote4.txt',targetNodeID);
		}
	}else{
		//alert("LoadAFile");
		loadAFile(userTabpath,targetNodeID);
	}
}

////////////////////////////////////////////////////////////////////////////////
// loadIt
//
// Desc: Loads the files
// Parameters: fileName: The name of the file to save two. targetNodeID: Where it is headed to (onePad, twoPad)
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
function loadIt(fileName,targetNodeID) {
	var d = new DirUtils;
	var p = d.getUserChromeDir();
	var fName = fileName;
	
	var f = new File(p);
	var target = f.nsIFile;
	var target2 = target;
	target.append(fName);
	
	f=new File(target.path);
	
	//If file already exists then just open it.
	if (f.exists()) {
		f.open()
		var stuff=f.read()
		f.close()
		setTextareaText(stuff,targetNodeID);
		
			if(targetNodeID == "onePad")
			{
				//alert("target.path: " + target.path + "\n f.path: " + f.path );
				nsPreferences.setUnicharPref('quicknote.tab1path', f.path);
			}
			if(targetNodeID == "twoPad")
			{
				nsPreferences.setUnicharPref('quicknote.tab2path', f.path);
			}
			if(targetNodeID == "threePad")
			{
				nsPreferences.setUnicharPref('quicknote.tab3path', f.path);
			}
			if(targetNodeID == "fourPad")
			{
				nsPreferences.setUnicharPref('quicknote.tab4path', f.path);
			}
	}
	
	// If it doesn't exist, create the file, then make sure it exists, then open.
	else if (!f.exists() ) { 	
		f.create();
		
		if (f.exists()) {
			f.open()
			var stuff=f.read()
			f.close()
			setTextareaText(stuff,targetNodeID);
			if(targetNodeID == "onePad")
			{
				//alert("target.path: " + target.path + "\n f.path: " + f.path );
				nsPreferences.setUnicharPref('quicknote.tab1path', f.path);
			}
			if(targetNodeID == "twoPad")
			{
				nsPreferences.setUnicharPref('quicknote.tab2path', f.path);
			}
			if(targetNodeID == "threePad")
			{
				nsPreferences.setUnicharPref('quicknote.tab3path', f.path);
			}
			if(targetNodeID == "fourPad")
			{
				nsPreferences.setUnicharPref('quicknote.tab4path', f.path);
			}
		}
		else {setTextareaText('// #2 Currently you do not have a user.js file.',targetNodeID)}
		
	}
	else {setTextareaText('// #1 Currently you do not have a user.js file.',targetNodeID)}
	
}

////////////////////////////////////////////////////////////////////////////////
// loadAFile
//
// Desc: Loads the files
// Parameters: fileName: The name of the file to save two. targetNodeID: Where it is headed to (onePad, twoPad)
// Returns: true or false
////////////////////////////////////////////////////////////////////////////////
function loadAFile(userTabpath, targetNodeID) {
	//var d = new DirUtils;
	//var myUserDirPlease = d.getUserChromeDir();
	var targetNodeID2 = targetNodeID;
	var PadfontSizetab, PadfontNametab, PadfontColortab, Paduserdefinedstyle, TabBGColor;
	
	//Set Tab Styles
	var oldStyles = document.getElementById(targetNodeID2).getAttribute("style");
	
	if(targetNodeID2 == "onePad")
	{
		PadfontSizetab = onePadfontSizetab;
		PadfontNametab = onePadfontNametab;
		PadfontColortab = onePadfontColortab;
		Paduserdefinedstyle = onePadUserStyletab;
		TabBGColor = oneTabBGColor;
	}
	if(targetNodeID2 == "twoPad")
	{
		PadfontSizetab = twoPadfontSizetab;
		PadfontNametab = twoPadfontNametab;
		PadfontColortab = twoPadfontColortab;
		Paduserdefinedstyle = twoPadUserStyletab;
		TabBGColor = twoTabBGColor;
		 
	}
	if(targetNodeID2 == "threePad")
	{
		PadfontSizetab = threePadfontSizetab;
		PadfontNametab = threePadfontNametab;
		PadfontColortab = threePadfontColortab;
		Paduserdefinedstyle = threePadUserStyletab;
		TabBGColor = threeTabBGColor;
	}
	if(targetNodeID2 == "fourPad")
	{
		PadfontSizetab = fourPadfontSizetab;
		PadfontNametab = fourPadfontNametab;
		PadfontColortab = fourPadfontColortab;
		Paduserdefinedstyle = fourPadUserStyletab;
		TabBGColor = fourTabBGColor;
	}
	document.getElementById(targetNodeID2).setAttribute("style", oldStyles + " font: " + PadfontSizetab.toString() +  "px " + PadfontNametab +  "; color:" + PadfontColortab +"; " + " -moz-appearance: none; background-color: "+ TabBGColor + "; " + Paduserdefinedstyle);
	
	
	
	
	
	if(userTabpath==null || userTabpath=='Blank'){
	    setTextareaText('//No file has been found!\n This could be caused by:\n 1) You have not re-opened QuickNote\n 2) You need to set your user File in the Prefernces\n 3)or the archive you chose is invalid.\n If you have done all these and still get an error, please contact the author at jedbro@gmx.net',targetNodeID);
	    return false;
	}
	var f = new File(userTabpath);
	var target = f.nsIFile;
	f=new File(target.path);
	
	//If file already exists then just open it.
	if (f.exists()) {
		f.open();
		var stuff=f.read();
		f.close();
		setTextareaText(stuff,targetNodeID);
	}
	
	// If it doesn't exist, Tell the user
	else if (!f.exists() ) { 	
		setTextareaText('// 2# File is invalid or does not exist..',targetNodeID);
		}
		
}


////////////////////////////////////////////////////////////////////////////////
// saveCurrent
//
// Desc: Saves the active pad to a corresponding file through a call to SaveIt
//       Used for Ctrl+S handling 
// Parameters: none
// Returns: nothing
// To-Do: get rid of functions -- Tab2Pad and Tab2Btn. Use more elegant construction.
////////////////////////////////////////////////////////////////////////////////
function Tab2Pad(s)
{
  if(s == "oneTab")
    return "onePad";
  else if(s == "twoTab")
    return "twoPad";
  else if(s == "threeTab")
    return "threePad";
  else if(s == "fourTab")
    return "fourPad";
  else {
    dump("QuickNote: bad tab id: " + s);
    return "";
  }
}
function Tab2Btn(s)
{
  if(s == "oneTab")
    return "save-one";
  else if(s == "twoTab")
    return "save-two";
  else if(s == "threeTab")
    return "save-three";
  else if(s == "fourTab")
    return "save-four";
  else {
    dump("QuickNote: bad tab id: " + s);
    return "";
  }
}

function saveCurrent()
{
  saveIt(Tab2Pad(document.getElementById("tabbox").selectedTab.id),
         Tab2Btn(document.getElementById("tabbox").selectedTab.id));
}


////////////////////////////////////////////////////////////////////////////////
// saveAll
//
// Desc: Saves all tabs using SaveIt
// Parameters: none
// Returns: nothing
// Note: Need to make it not cause an error do to lack of note open
////////////////////////////////////////////////////////////////////////////////
function saveAll()
{
  saveIt("onePad", "save-one");
  saveIt("twoPad", "save-two");
  saveIt("threePad", "save-three");
  saveIt("fourPad", "save-four");
}


////////////////////////////////////////////////////////////////////////////////
// saveIt
//
// Desc: Saves the file using JSlib DirUtils and File
// Parameters: fileName: The name of the file to save to. targetNodeID: Where it is headed to (onePad, twoPad). button: Which save button this affects!
// Returns: nothing
// To-Do: Merge saveIt and saveAFile. Stupid to have both!
////////////////////////////////////////////////////////////////////////////////
function saveIt(targetNodeID,button) {
	var data = getTextareaText(targetNodeID);
	//var d = new DirUtils;
	//var p = d.getUserChromeDir();
	var fName;
	if(targetNodeID == "onePad"){
			fName = userdefinedtab1file;

	}
	if(targetNodeID == "twoPad"){
			fName = userdefinedtab2file;

	}
	if(targetNodeID == "threePad"){
			fName = userdefinedtab3file;

	}
	if(targetNodeID == "fourPad"){
			fName = userdefinedtab4file;
	}
	
	
	var f = new File(fName);
	var target = f.nsIFile;
	//target.append(fName);  
	f=new File(target.path);
	
	f.open('w');
	// File::write() returns false if data==null
	// Still it is ok to save a blank file (note: File::open('w') 
	// overwrites the file if it already exists)
	if(data) {
		p = f.write(data);
	} else {
		p = true;
	}
	f.close();
	
	if(p)
		document.getElementById(button).setAttribute("disabled", "true");
}

////////////////////////////////////////////////////////////////////////////////
// saveIfChanged
//
// Desc: Auto-save function!
// Parameters: none
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
function saveIfChanged() {

    if ( ! document.getElementById('save-one').hasAttribute('disabled') )
      saveIt('onePad', 'save-as1');

    if ( ! document.getElementById('save-two').hasAttribute('disabled') )
      saveIt('twoPad', 'save-as2');
    
    if ( ! document.getElementById('save-three').hasAttribute('disabled') )
      saveIt('threePad', 'save-as3');
    
    if ( ! document.getElementById('save-four').hasAttribute('disabled') )
      saveIt('fourPad', 'save-as4');

}

////////////////////////////////////////////////////////////////////////////////
// CatchText
//
// Desc: Catch text sent via context menu
// Parameters: text to catch
// Returns: the tab-id which got the text
////////////////////////////////////////////////////////////////////////////////

function catchText(text)
{
// ## Decides where to send the text to.. ##
 if (tabtosendto && tabtosendto >='2'){
	  
	  if(tabtosendto == '2')
	  {
		if(text){
			twoPad = document.getElementById("twoPad");
			twoPad.value = twoPad.value+"\n";
			twoPad.value = twoPad.value+text+"\n";
			saveIt('twoPad', 'save-two');
			twoPad.focus();
			sizeToContent();
			return "twoPad";
		}
	  }
	  if(tabtosendto == '3')
	  {
		  if(text){
			  threePad = document.getElementById("threePad");
			  threePad.value = threePad.value+"\n";
			  threePad.value = threePad.value+text+"\n";
			  saveIt('threePad', 'save-three');
			  sizeToContent();
			  threePad.focus();
			return "threePad";
		  }
	  }
	  if(tabtosendto == '4')
	  {
		  if(text){
			  fourPad = document.getElementById("fourPad");
			  fourPad.value = fourPad.value+"\n";
			  fourPad.value = fourPad.value+text+"\n";
			  saveIt('fourPad', 'save-four');
			  sizeToContent();
			  fourPad.focus();
			return "fourPad";
		  }
	  }


  }else{
	  // This is causing the extra /n to apear.
	  if(text){
		  onePad = document.getElementById("onePad");
		  onePad.value = onePad.value+"\n";
		  onePad.value = onePad.value+text+"\n";
		  saveIt('onePad', 'save-one');
		  sizeToContent();
		  onePad.focus();
		return "onePad";
	  }
  }
}

////////////////////////////////////////////////////////////////////////////////
// OnLoad
//
// Desc: Make sure this loads with QuickNote to get the onePad data
// Parameters: onePad to copy the selection (via arguments[0])
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
function OnLoad() {
	var onePad;  // textbox holding the text to copy from onePad
	var twoPad;  // textbox holding the text to copy from twoPad
	var oneTab;  // Tab number one
	var twoTab;  // Tab number two
	if(numberoftabs == '0' || numberoftabs == '1')
	{
		document.getElementById("oneTab").collapsed = false;
		document.getElementById("twoTab").collapsed = true;
		document.getElementById("threeTab").collapsed = true;
		document.getElementById("fourTab").collapsed = true;
		loadtheFiles(userdefinedtab1file,'onePad');
		loadtheFiles(userdefinedtab2file,'twoPad');
		loadtheFiles(userdefinedtab3file,'threePad');
		loadtheFiles(userdefinedtab4file,'fourPad');
	}
	if(numberoftabs == '2')
	{
		document.getElementById("twoTab").collapsed = false;
		loadtheFiles(userdefinedtab1file, 'onePad');
		loadtheFiles(userdefinedtab2file,'twoPad');
		loadtheFiles(userdefinedtab3file,'threePad');
		loadtheFiles(userdefinedtab4file,'fourPad');
	}
	if(numberoftabs == '3')
	{
		document.getElementById("twoTab").collapsed = false;
		document.getElementById("threeTab").collapsed = false;
		loadtheFiles(userdefinedtab1file, 'onePad');
		loadtheFiles(userdefinedtab2file,'twoPad');
		loadtheFiles(userdefinedtab3file,'threePad');
		loadtheFiles(userdefinedtab4file,'fourPad');
	}
	if(numberoftabs == '4')
	{
		document.getElementById("twoTab").collapsed = false;
		document.getElementById("threeTab").collapsed = false;
		document.getElementById("fourTab").collapsed = false;
		loadtheFiles(userdefinedtab1file, 'onePad');
		loadtheFiles(userdefinedtab2file,'twoPad');
		loadtheFiles(userdefinedtab3file,'threePad');
		loadtheFiles(userdefinedtab4file,'fourPad');
	}if(!numberoftabs)
	{
		document.getElementById("threeTab").collapsed = true;
		document.getElementById("fourTab").collapsed = true;
		
		loadtheFiles(userdefinedtab1file, 'onePad');
		loadtheFiles(userdefinedtab2file,'twoPad');
		loadtheFiles(userdefinedtab3file,'threePad');
		loadtheFiles(userdefinedtab4file,'fourPad');
	}
	
	if(!qnfirststart || qnfirststart == false){
		alert("Welcome to QuickNote:\n This is your first time using QN.\n Please set your preferences and re-load QuickNote!");
		window.close();
		window.open('qnsettings.xul','QuickNote - Settings','chrome,centerscreen,resizable'); 
		return;
	}

	var caughtText = null;
	try {
		caughtText = catchText(window.arguments[0]);
	} catch(e) { caughtText = null; } 

	if(caughtText == null){
		var thePadId = Tab2Pad(document.getElementById("tabbox").selectedTab.id);
		var thePad = document.getElementById(thePadId);
		thePad.focus();
	}
	

}

//**** SaveAS and FilePicker ******

////////////////////////////////////////////////////////////////////////////////
// txtFilePicker
//
// Parameters:
//  aTitle: title to go on file picker window
//  aSave: 1 if picking file to save/overwrite, 0 if picking file to load
//  aStart: directory to start from
//    This must be an nsILocalFile.  new Dir("foo") in jslib/io/dir.js will
//    do the trick, but you have to do it yourself.
// Returns:
//  Name of file picked, in URL format, or null if cancelled
// Original taken and modified from Tagzilla.mozdev.org!
////////////////////////////////////////////////////////////////////////////////
function txtFilePicker(aTitle, aSave) {
  var retVal = null;
  try {
   
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, aTitle, (aSave ? nsIFilePicker.modeSave : nsIFilePicker.modeOpen));
    fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);
    
    /*
    if(aStart) {
      fp.displayDirectory = aStart;
    }
    */
    var result=fp.show();
    if (result == nsIFilePicker.returnOK || result == nsIFilePicker.returnReplace) {
      //retVal=fp.fileURL.spec;
      retVal=fp.file.path;
      //alert("Should return retval: "+retVal+" YES!"); // DEBUG
    }
  }
  catch (ex) {
  }
  return retVal;
}

////////////////////////////////////////////////////////////////////////////////
// saveListAs
//
// Parameters: targetNodeID: What to save
// button: Which button was pressed
// Returns: true if list saved, false otherwise
// Original taken and modified from Tagzilla.mozdev.org!
////////////////////////////////////////////////////////////////////////////////
function saveListAs(targetNodeID, button) {
  var d = new DirUtils;
  var myUserDirPlease = d.getUserChromeDir();
  var targetNodeID2 = targetNodeID;
  var fName = txtFilePicker("Save the File as",1,myUserDirPlease);
  if(fName==null){
    return false;
  }
  
  var isSaved = saveAFile(fName, targetNodeID2, button);
  //if(isSaved){
	//document.getElementById(button).setAttribute("disabled", "true");
  //}
  
  return isSaved;
}

////////////////////////////////////////////////////////////////////////////////
// saveAFile
//
// Parameters:
//  aUrl: string name of file to open, in platform-specific or file:// format
//  targetNodeID: where the data is to save!
//  button: The button that makes the call (for disable/enable)
// Returns: true if list saved, false otherwise
// To-Do: Merge saveIt and saveAFile. Stupid to have both!
////////////////////////////////////////////////////////////////////////////////
function saveAFile(aUrl, targetNodeID, button) {

  var aFile=aUrl;
  if(aUrl.substring(0,4)=="file") {
    var fUtils = new FileUtils();
    aFile = fUtils.urlToPath(aUrl);
  }

  var f = new File(aFile);
  if(!f.open("w")) {
    alert("File could not be opened!");
    return false;
  }
  //f.write(tzList.join("\n")+"\n");
  var data = getTextareaText(targetNodeID);
  f.write(data);
  f.close();
  
  //document.getElementById(button).setAttribute("disabled", "true");
  return true;
}


////////////////////////////////////////////////////////////////////////////////
// mailIt
//
// Parameters:
//  targetNodeID: where the data is to save!
// Returns: true
// To-Do: TESTING, can't get to get Thunderbird to load a Compose window 
////////////////////////////////////////////////////////////////////////////////
function qnMailWindow(targetNodeID) {
	var QNmailText = getTextareaText(targetNodeID).value;
	window.openDialog("chrome://quicknote/content/mail.xul",
		  "_blank", "chrome,all,dialog", QNmailText);
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// Open QN by pref
//
// Desc: Opens QuickNote depending on set pref
////////////////////////////////////////////////////////////////////////////////
function openQuickNote() {
	try {
	const pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var howtopenQN = pref.getIntPref('quicknote.openqn',null);
	}catch (e) {
	// foobar!
	}
	
	if(howtopenQN == '0'){
		toggleSidebar('viewQuickNoteSidebar');
		return;
				
	}
	if(!howtopenQN || howtopenQN == '1'){
		toOpenWindowByType('QuickNote','chrome://quicknote/content/quicknote.xul');
		return;
	}
	if(howtopenQN == '2'){
		BrowserOpenTab(); 
		openTopWin("chrome://quicknote/content/quicknote.xhtml");
		return;
	}
		
}
